<!-- 编辑弹窗 -->
<template>
  <ele-modal
    :width="800"
    :visible="visible"
    :maskClosable="false"
    :maxable="maxable"
    :title="isUpdate ? '编辑数据统计' : '添加数据统计'"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    @ok="save"
  >
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 4, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="
        styleResponsive ? { md: 19, sm: 19, xs: 24 } : { flex: '1' }
      "
    >
      <a-form-item label="用户ID" name="userId">
        <a-input
          allow-clear
          placeholder="请输入用户ID"
          v-model:value="form.userId"
        />
      </a-form-item>
      <a-form-item label="待处理数" name="pending">
        <a-input
          allow-clear
          placeholder="请输入待处理数"
          v-model:value="form.pending"
        />
      </a-form-item>
      <a-form-item label="闲置的工单(废弃)" name="unused">
        <a-input
          allow-clear
          placeholder="请输入闲置的工单(废弃)"
          v-model:value="form.unused"
        />
      </a-form-item>
      <a-form-item label="已完成数(废弃)" name="completed">
        <a-input
          allow-clear
          placeholder="请输入已完成数(废弃)"
          v-model:value="form.completed"
        />
      </a-form-item>
      <a-form-item label="今天处理数" name="today">
        <a-input
          allow-clear
          placeholder="请输入今天处理数"
          v-model:value="form.today"
        />
      </a-form-item>
      <a-form-item label="本月处理数" name="month">
        <a-input
          allow-clear
          placeholder="请输入本月处理数"
          v-model:value="form.month"
        />
      </a-form-item>
      <a-form-item label="今年处理数" name="year">
        <a-input
          allow-clear
          placeholder="请输入今年处理数"
          v-model:value="form.year"
        />
      </a-form-item>
      <a-form-item label="总工单数" name="total">
        <a-input
          allow-clear
          placeholder="请输入总工单数"
          v-model:value="form.total"
        />
      </a-form-item>
      <a-form-item label="部门ID" name="organizationId">
        <a-input
          allow-clear
          placeholder="请输入部门ID"
          v-model:value="form.organizationId"
        />
      </a-form-item>
      <a-form-item label="角色ID" name="roleId">
        <a-input
          allow-clear
          placeholder="请输入角色ID"
          v-model:value="form.roleId"
        />
      </a-form-item>
      <a-form-item label="角色标识" name="roleCode">
        <a-input
          allow-clear
          placeholder="请输入角色标识"
          v-model:value="form.roleCode"
        />
      </a-form-item>
      <a-form-item label="更新时间" name="updateTime">
        <a-input
          allow-clear
          placeholder="请输入更新时间"
          v-model:value="form.updateTime"
        />
      </a-form-item>
    </a-form>
  </ele-modal>
</template>

<script lang="ts" setup>
  import { ref, reactive, watch } from 'vue';
  import { Form, message } from 'ant-design-vue';
  import { assignObject, uuid } from 'ele-admin-pro';
  import { addOaTaskCount, updateOaTaskCount } from '@/api/oa/oaTaskCount';
  import { OaTaskCount } from '@/api/oa/oaTaskCount/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { ItemType } from 'ele-admin-pro/es/ele-image-upload/types';
  import { FormInstance } from 'ant-design-vue/es/form';
  import { FileRecord } from '@/api/system/file/model';

  // 是否是修改
  const isUpdate = ref(false);
  const useForm = Form.useForm;
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    data?: OaTaskCount | null;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  // 提交状态
  const loading = ref(false);
  // 是否显示最大化切换按钮
  const maxable = ref(true);
  // 表格选中数据
  const formRef = ref<FormInstance | null>(null);
  const images = ref<ItemType[]>([]);

  // 用户信息
  const form = reactive<OaTaskCount>({
    taskCountId: undefined,
    userId: undefined,
    pending: undefined,
    unused: undefined,
    completed: undefined,
    today: undefined,
    month: undefined,
    year: undefined,
    total: undefined,
    organizationId: undefined,
    roleId: undefined,
    roleCode: undefined,
    tenantId: undefined,
    createTime: undefined,
    updateTime: undefined,
    oaTaskCountId: undefined,
    oaTaskCountName: '',
    status: 0,
    comments: '',
    sortNumber: 100
  });

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表单验证规则
  const rules = reactive({
    oaTaskCountName: [
      {
        required: true,
        type: 'string',
        message: '请填写数据统计名称',
        trigger: 'blur'
      }
    ]
  });

  const chooseImage = (data: FileRecord) => {
    images.value.push({
      uid: data.id,
      url: data.path,
      status: 'done'
    });
    form.image = data.path;
  };

  const onDeleteItem = (index: number) => {
    images.value.splice(index, 1);
    form.image = '';
  };

  const { resetFields } = useForm(form, rules);

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const formData = {
          ...form
        };
        const saveOrUpdate = isUpdate.value ? updateOaTaskCount : addOaTaskCount;
        saveOrUpdate(formData)
          .then((msg) => {
            loading.value = false;
            message.success(msg);
            updateVisible(false);
            emit('done');
          })
          .catch((e) => {
            loading.value = false;
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.visible,
    (visible) => {
      if (visible) {
        images.value = [];
        if (props.data) {
          assignObject(form, props.data);
          if(props.data.image){
            images.value.push({
              uid: uuid(),
              url: props.data.image,
              status: 'done'
            })
          }
          isUpdate.value = true;
        } else {
          isUpdate.value = false;
        }
      } else {
        resetFields();
      }
    },
    { immediate: true }
  );
</script>
